//+------------------------------------------------------------------+
//|                                                        Azrul.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property stacksize 8000000
string EAName="Azrul:";
int  EANumbers=012345;
//---
#define  OPN_BUY           000
#define  OPN_SELL          001
#define  OPN_BUY_LIMIT     002
#define  OPN_SELL_LIMIT    003
#define  OPN_BUY_STOP      004
#define  OPN_SELL_STOP     005
#define  CLS_BUY           110
#define  CLS_SELL          111
#define  DEL_PO_BUY        120
#define  DEL_PO_SELL       121
#define  MDF_BUY           130
#define  MDF_SELL          131
//---
int TF[9]={1,5,15,30,60,240,1440,10080,43200};
enum g {minit_1=0,minit_5=1,minit_15=2,minit_30=3,hour_1=4,hour_4=5,daily_1=6,weekly_1=7,monthly_1=8};

//---
extern g tf                      =hour_1;// SettingTimeframe
extern double LotExponent = 1.2;
extern double Lotstart           =0.01;//Lot Sizing,0.0-auto
extern double lot_increment      =0.01;
extern int  bilopen              =2;// Bilangan Entry
extern int pipstep               =50;//step dalam pip untuk po
extern int take_profit           =0;//Take profit
extern int stop_loss             =0;//Stop Loss

   int Q=0,Cnt=-1;
   int q=0;
   int ICnt=0,OPn=0;
   int nb[2];
//---++++++++++++++++++++++++++++++
//---
int count=0;
double iLots = 0.0;
double LastBuyPrice = 0.0;
double LastSellPrice = 0.0;
double PriceTarget = 0.0;
double Stopper = 0.0;
double StartEquity = 0.0;
double AveragePrice = 0.0;
double totalLot = 0.0;
int TOTAL = 0;
int NumOfTrades = 0;
bool TradeNow = FALSE;
bool LongTrade = FALSE;
bool ShortTrade = FALSE;
bool flag = FALSE;
bool NewOrdersPlaced = FALSE;
//---
//---+++++++++++++++++++++++++++++

//---id()
double profit=0.0;
int buys=0,sells=0;
int signal=0;
//---atur price
double stop=0.0,freeze=0.0,vask=0.0,vbid=0.0,spread=0.0,lvl=0.0,point=0.0;int sprd=0;
//-----------------------------struct data
class data
{
   public:
      enum
      {sz=20};
      static double 
      rsi_14[sz],
      rsi_3[sz],
      stc_fast[sz],
      stc_slow[sz],
      mom14[sz],
      will[sz];
        //---
         data(){}
         ~data(){}
      //---
      //---function---//
      static int base(int);
      static void calc();
      static int iset(int);//---set---/
      static int ArrayCheck();//---reset---/
      
};
double 
data::rsi_14[sz]={0.0},
data::rsi_3[sz]={0.0},
data::stc_fast[sz]={0.0},
data::stc_slow[sz]={0.0},
data::mom14[sz]={0.0},
data::will[sz]={0.0};

//-----------------------------struct order
class io:public data
{                                         
   public:
   int 
   EANumber,//<--copy magik number
   sig;
   //---
   int o_send,o_typ;
   string o_sym;
   datetime
   o_time;
   double 
   o_lot,
   c_price,
   o_price,
   o_sl,
   o_tp,
   o_profit;
   int
   flag;
   //---
   double s_price,s_st,s_tp;//<--ini untuk tolong semak tetapkan nilai
   bool ea_c;
   bool closeBUY,closeSELL;
   //------------------------------------------------------MODIFY 
   //---semak
   int
   hedge;
   //------------------------------------------------------
   
         io():
         EANumber(0),sig(0),
         o_send(-1),o_typ(-1),
         o_sym(""),
         o_time(0),
         o_lot(0.0),c_price(0.0),o_price(0.0),
         o_sl(0.0),o_tp(0.0),o_profit(0.0),
         flag(0),
         s_price(0.0),s_st(0.0),s_tp(0.0),
         ea_c(false),closeBUY(false),closeSELL(false),
         
         hedge(0)
         {}
         ~io(){}
         void set(){
                        EANumber=OrderMagicNumber();//0<utama>
                        o_sym=OrderSymbol();//1
                        o_time=OrderOpenTime();//2
                        o_typ=OrderType();//3
                        o_lot=OrderLots();//4
                        o_price=OrderOpenPrice();//5
                        o_sl=OrderStopLoss();//6
                        o_tp=OrderTakeProfit();//7
                        c_price=OrderClosePrice();//8
                        o_profit=OrderProfit()+OrderCommission()+OrderSwap();//9
                     }
         void reset(){
                        EANumber=0;sig=0;
                        o_sym="";
                        o_send=-1;o_typ=-1;
                        o_time=0;
                        o_lot=0.0;c_price=0.0;o_price=0.0;
                        o_sl=0.0;o_tp=0.0;o_profit=0.0;
                        flag=0;
                        s_price=0.0;s_st=0.0;s_tp=0.0;
                        ea_c=false;
                        }
         bool atur(double Lot=0.0,int code=-1,double sl=0.0,double tp=0.0,double price=0.0);
         bool open(int,int);
         bool close(int);
         bool del(int);
         bool modify(int,double,double);
         //---
         //---
         double mmgm(int,int);       
}O[];
//---time log prop
int tlog=0,tsleep=0;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ArrayResize(O,bilopen,bilopen);ArrayInitialize(nb,0);
   //---Penting!!
   if(tlog!=TerminalInfoInteger(TERMINAL_PING_LAST)){tlog=TerminalInfoInteger(TERMINAL_PING_LAST);}else tlog=tlog;
   tsleep=(int)((tlog*0.001)+100);
//---
//---STOP/FREEZE
   stop=(int)MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(),MODE_POINT);//modify,open
   freeze=(int)MarketInfo(Symbol(),MODE_FREEZELEVEL)*MarketInfo(Symbol(),MODE_POINT);//modify,cancel,close
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool newb(){if(nb[0]!=iBars(_Symbol,TF[tf])){nb[0]=iBars(_Symbol,TF[tf]);nb[1]=1;return true;}else{nb[1]=0;}return false;}
//+------------------------------------------------------------------+
//|                        Normalize                                 |
//+------------------------------------------------------------------+
void NormPrice(double& j)
{j=j*MathPow(10,Digits);j=MathRound(j);j=j/MathPow(10,Digits);} 

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
//---penting!
   vask=Ask;
   vbid=Bid;
   spread=vask-vbid;
   //----------------------------------COUNT/DETECT ORDER-----------------------------------------------
                              Q=id();
   if(newb()) {RefreshRates();ICnt++;OPn=0;if(Cnt>0)Cnt++;else Cnt=0;}//count and reset
   if(q<Q){q=Q;OPn++;if(Cnt<=0)Cnt=1;else Cnt=Cnt;}else {if(q>Q){q=Q;Cnt=0;}}
   //+------------------------------------------------------------------+
                     if(ICnt>10000)ICnt=0;
   //+------------------------------------------------------------------+
//---Kiraan Indicator:
   //---
   data::calc();
   //---
   //---Logical Condition:
   int keyy=0;keyy=data::base(Q);          
   //------------------------------CONDITION
   TOTAL = Q;
   //---
   if (TOTAL == 0) flag = FALSE;
         if (buys>0) {
            LongTrade = TRUE;
            ShortTrade = FALSE;
         }
         if (sells<0) {
            LongTrade = FALSE;
            ShortTrade = TRUE;
         }
   if (TOTAL > 0 && TOTAL <= bilopen) {
      RefreshRates();
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      //---
      if (LongTrade  && LastBuyPrice - Ask >= pipstep * Point)    TradeNow = TRUE;
      if (ShortTrade && Bid - LastSellPrice >= pipstep * Point)   TradeNow = TRUE;
      //---
      
   }
   if (TOTAL < 1) {
      ShortTrade = FALSE;
      LongTrade = FALSE;
      TradeNow = TRUE;
      StartEquity = AccountEquity();
   }
   if (TradeNow) {
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      //---
      if (ShortTrade) {
         NumOfTrades = TOTAL;
         //---
         iLots = NormalizeDouble(Lotstart * MathPow(LotExponent, bilopen),2);// Kiraan Lots
         //---
         RefreshRates();
         //ticket = OpenPendingOrder(OP_SELL, iLots, Bid, slip, Ask, 0, 0, EAName + "-" + NumOfTrades, EANumber, 0, HotPink);
         if (io::atur(iLots,OP_SELL)==false) {
            return ;
         }
         LastSellPrice = FindLastSellPrice();
         TradeNow = FALSE;
         NewOrdersPlaced = TRUE;
      } else {
         //---
         if (LongTrade) {
            NumOfTrades = TOTAL;
            iLots = NormalizeDouble(Lotstart * MathPow(LotExponent, bilopen),2);
            //ticket = OpenPendingOrder(OP_BUY, iLots, Ask, slip, Bid, 0, 0, EAName + "-" + NumOfTrades, EANumber, 0, SkyBlue);
            if (io::atur(iLots,OP_BUY)==false) {
               return;
            }
            LastBuyPrice = FindLastBuyPrice();
            TradeNow = FALSE;
            NewOrdersPlaced = TRUE;
         }
      }
   }
   //---
   //---
   if (TradeNow && TOTAL < 1) {
      //---
      //---
      double rsi[3]={0.0};
      for(int r=0;r<3;r++)
      {
      rsi[r]=iRSI(NULL, PERIOD_H1, 14, PRICE_CLOSE, r);
      }
      
      //---
      //---
      vbid = Bid;
      vask = Ask;
      //---
      //---
      //---
      if ((!ShortTrade) && (!LongTrade)) {
         NumOfTrades = TOTAL;
         //---
         iLots = NormalizeDouble(Lotstart * MathPow(LotExponent, bilopen),2);
         //--- Open Sell
         //---
         //if(ma_slow[0][1] > ma_fast[0][1])
         //if((ma_slow[1][1] < ma_fast[1][1])&&(ma_slow[0][1] > ma_fast[0][1])) 
         //---
         //if(rsi[2]>rsi[1])
         //---
         {
            if (rsi[1] > 30.0) 
               //---
               {
               //ticket = OpenPendingOrder(1, iLots, vbid, slip, vbid, 0, 0, EAName + "-" + NumOfTrades, EANumber, 0, Red);
               if (io::atur(iLots,OP_SELL)) {
                  Print("Error: ", GetLastError());
                  return;
               }
               LastBuyPrice = FindLastBuyPrice();
               NewOrdersPlaced = TRUE;
            }
         } //else 
         //---
         //---
         //if(ma_slow[0][1] < ma_fast[0][1])
         //if((ma_slow[1][1] > ma_fast[1][1])&&(ma_slow[0][1] < ma_fast[0][1])) 
         //---
         //---
         {
            //--- Open Buy
            
            if (rsi[1] < 70.0) 
               
               //---
               //---
               {
               //ticket = OpenPendingOrder(0, iLots, vask, slip, vask, 0, 0, EAName + "-" + NumOfTrades, EANumber, 0, Blue);
               if (io::atur(iLots,OP_BUY)==false) {
                  Print("Error: ", GetLastError());
                  return ;
               }
               LastSellPrice = FindLastSellPrice();
               NewOrdersPlaced = TRUE;
            }
         }
         TradeNow = FALSE;
      }
   }
   //---
   //--- kiraan semula total
   AveragePrice = 0;
   totalLot = 0.0;
   TOTAL = id();
   //---
   if (TOTAL > 0) AveragePrice = NormalizeDouble(AveragePrice / totalLot, Digits);
   //---
   if (NewOrdersPlaced) {
      for (count = OrdersTotal() - 1; count >= 0; count--) {
         if(OrderSelect(count, SELECT_BY_POS, MODE_TRADES)!=true)continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == EANumbers) {
            if (OrderType() == OP_BUY) {
               PriceTarget = AveragePrice + take_profit * Point;
               Stopper     = AveragePrice - stop_loss * Point;
               flag        = TRUE;
            }
         }
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == EANumbers) {
            if (OrderType() == OP_SELL) {
               PriceTarget = AveragePrice - take_profit * Point;
               Stopper     = AveragePrice + stop_loss * Point;
               flag        = TRUE;
            }
         }
      }
   }
   if (NewOrdersPlaced) {
      if (flag == TRUE) {
         for (count = OrdersTotal() - 1; count >= 0; count--) {
            if(OrderSelect(count, SELECT_BY_POS, MODE_TRADES)!=true)continue;
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == EANumbers) bool mod=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), PriceTarget, 0, Yellow);
            NewOrdersPlaced = FALSE;
         }
      }
   }
   

   //------------------------------CLOSE/DELETE/MODIFY--------------------------------------------------
   if(Q>0)
   {
   for(int rl=0,OrderActive=0; (rl<ArraySize(O)&&(OrderActive<bilopen)); rl++){
                                              
                                       if(OrderSelect(O[rl].o_send,SELECT_BY_TICKET,MODE_TRADES)==TRUE)if(OrderMagicNumber()==EANumbers){
                                       //---
                                       if( signal==101)
                                       {
                                          if(O[rl].o_typ>1 && O[rl].o_typ<6)//DELETE   po order
                                          {
                                             O[rl].del(O[rl].o_typ);
                                          }
                                          else
                                          if(O[rl].o_typ==0 || O[rl].o_typ==1)//CLOSE   instant order
                                          {
                                             O[rl].close(O[rl].o_typ);
                                          }
                                       }//signal
                                       //---Modify
                                       //O[rl].modify(O[rl].o_typ,data::sl_be,O[rl].o_tp);
   }}
   }//--closing
                                       signal=0;//reset signal   
  Comment(
   "Cnt= ",Cnt,"  Q= ",Q,"\n",
   "keyy= ",keyy,"\n",
  "rsi= ",data::rsi_14[0],"\n",
  "will= ",data::will[0],"\n",
  "");
  }//--Ontick
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+Close
bool io::close(int i=-1)
{
   if(i==OP_BUY)
   {
   if(atur(0.0,CLS_BUY)){return true;}
   }
   if(i==OP_SELL)
   {
   if(atur(0.0,CLS_SELL)){return true;}
   }
   return false;
}
//+------------------------------------------------------------------+Delete
bool io::del(int i=-1)
{
      //---
      if(i%2==0)//--po buy
         if(atur(0.0,DEL_PO_BUY)){return(true);}
         
      if(i%2==1)//--po sell
         if(atur(0.0,DEL_PO_SELL)){return(true);}   
      //---
      //---
   return(false);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double FindLastBuyPrice() {
   int oldticketnumber=0, ticketnumber=0;
   double oldorderopenprice=0.0, orderprice=0.0;
   for (int ii = OrdersTotal() - 1; ii >= 0; ii--) {
      if(OrderSelect(ii, SELECT_BY_POS, MODE_TRADES)!=true)continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == EANumbers && OrderType() == OP_BUY) {
         ticketnumber = OrderTicket();
         if (ticketnumber > oldticketnumber) {
            orderprice = OrderOpenPrice();
            oldorderopenprice = orderprice;
            oldticketnumber = ticketnumber;
         }
      }
   }
   return (orderprice);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double FindLastSellPrice() {
   int oldticketnumber=0, ticketnumber=0;
   double oldorderopenprice=0.0, orderprice=0.0;
   for (int ii = OrdersTotal() - 1; ii >= 0; ii--) {
      if(OrderSelect(ii, SELECT_BY_POS, MODE_TRADES)!=true)continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == EANumbers && OrderType() == OP_SELL) {
         ticketnumber = OrderTicket();
         if (ticketnumber > oldticketnumber) {
            orderprice = OrderOpenPrice();
            oldorderopenprice = orderprice;
            oldticketnumber = ticketnumber;
         }
      }
   }
   return (orderprice);
}
//+------------------------------------------------------------------+
//|                       Identify() Id                              |
//+------------------------------------------------------------------+
int id()
  {
   int 
   i=0,
   ii=0,
   iii=0;
   int 
   idt=OrdersTotal();
   //---reset 
   int 
   iQ=0,
   oQ=0;
   //---
   profit=0.0;buys=0;sells=0;
   //---
   //---
   
         //---                   Checking Flag Order
         
         //---
         for( ii=0; ii<ArrayRange(O,0);ii++)//  -->>roll call for list order<<--
         {
         if(OrderSelect(O[ii].o_send,SELECT_BY_TICKET,MODE_HISTORY)==true)
         if(OrderSymbol()==Symbol())
         if(OrderMagicNumber()==EANumbers)
         if(OrderCloseTime()!=0)
            {
               int ot=OrderType();
               if((ot==0)||(ot==1))
               {
               //---Detect close by 1.ea close 2.takeprofit/stoploss/traillingstop 3. manual
               //---1. ea close
               if(O[ii].ea_c)
                  {
                     if(ot==0)O[ii].flag= 5;
                     if(ot==1)O[ii].flag=-5;
                  }
               else
               //---2.takeprofit/stoploss:traillingstop
               if(OrderClosePrice()==OrderTakeProfit()||OrderClosePrice()==OrderStopLoss()){
                     if(ot==0)O[ii].flag= 4;
                     if(ot==1)O[ii].flag=-4;
                  }
                else  
               //---3. manual
                  {
                     if(ot==0)O[ii].flag= 3;
                     if(ot==1)O[ii].flag=-3;
                  }
               //---
               signal=101;
               //---
               }
               else 
               {//--Deleted pending order
                     if(ot%2==0)O[ii].flag= 2;
                     if(ot%2==1)O[ii].flag=-2;
               }
               /*
               */
               //------------Delete other object
               if(!IsTesting())
               {
                  int total=ObjectsTotal(); 
                  for(int v=0;v<=total;v++) 
                  { 
                  string obj_name=ObjectName(v); 
                  if(StringSubstr(obj_name,0,5)!="label"){ObjectDelete(obj_name);}
                  }
               }
               //------------
               O[ii].reset();
               //------------
           }
         }  
      //---
      //---
      for( i=0; i<idt&&!IsStopped(); i++)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)!=true)continue;
         if(OrderSymbol()==Symbol())//--tapis symbol
         if(OrderMagicNumber()==EANumbers)//--filter magic number
         {
            //---
            iQ++; 
            //---Profits
            profit+=OrderProfit()+OrderSwap()+OrderCommission();
            AveragePrice += OrderOpenPrice() * OrderLots();
            totalLot += OrderLots();
            //---CalculateCurrentOrders
            if(OrderType()==OP_BUY)  buys++;
            if(OrderType()==OP_SELL) sells--;
            //---
                  for(ii=0;ii<ArrayRange(O,0);ii++){//--cari ordersend yg sama
                     if(O[ii].o_send==OrderTicket())
                     {
                     //---
                     oQ++;
                     //---
                     O[ii].set();
                     }
                  }
               
         }
      }
   //---------------<<  berlaku semasa EA ditutup - variable semua reset   >>---------------
                              if(oQ<iQ)
                              {
                              //clean();
                                 for(i=0;i<idt&&!IsStopped();i++){
                                 if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)!=TRUE)continue;
                                 if(OrderSymbol()==Symbol())
                                 if(OrderMagicNumber()==EANumbers)
                                 {
                                    for( iii=0; iii<ArraySize(O);iii++){
                                       if(O[iii].o_send==-1)
                                       {
                                          O[iii].set();
                                       if(O[iii].o_send!=-1)break;
                                       }}
                                 }}      
                              }
   return(iQ);
  }
//+------------------------------------------------------------------+
//|    open order:                                                   |
//|          code= 000-OP_BUY,  002-OP_BUYLIMIT,  004-OP_BUYSTOP,    |
//|                001-OP_SELL, 003-OP_SELLLIMIT  005-OP_SELLSTOP,   |
//|    operation market order:                                       |
//|          code= 11x-Close order ->xBUY/SELL                       |
//|                12x-Delete pending order ->xBUY/SELL              |
//|                13x-Modify order ->xBUY/SELL                      |
//|                14x-ATOTRAIL order ->xBUY/SELL                    |
//|                                                                  |
//|          x=kedudukan market, y=operasi, z=Type                   |
//+------------------------------------------------------------------+
bool io::atur(double Lot=0.0,int code=-1,double sl=0.0,double tp=0.0,double price=0.0)
  {
   bool rtn=false;
   //---code analysis
   int lp=10;
   static int ctr=0;ctr=(int)NormalizeDouble((((vask-vbid)/2)/Point),0);ctr=ctr==0? 5:ctr;//slippage
   int x=0,y=0,z=0;x=code/100;y=(code%100)/10;z=(code%100)%10;
   if(code>=0)
   if((price>=0.0)&&(sl>=0.0&&tp>=0.0))
   {
   //---Normalize all prices   
   NormPrice(price);NormPrice(sl);NormPrice(tp);
   //---
   //---
   switch(x)
   {
      case 0:
            {
               if(price>0.0)
                 {
                  switch(z)
                    {
                     case 0:  {//--price
                               if((price<vask)&&(vask-price>=stop)){z=2;price=price;}//--2
                               else
                               if((price>vask)&&(price-vask>=stop)){z=4;price=price;}//--4
                               else price=vask;
                               break;//--break z
                               }
                     case 1:  {
                               if((price>vbid)&&(price-vbid>=stop)){z=3;price=price;}//--3
                               else
                               if((price<vbid)&&(vbid-price>=stop)){z=5;price=price;}//--5
                               else price=vbid;
                               break;//--break z
                               }
                     case 2:  {price=((price<vask)&&(vask-price>=stop))? price:vask-stop;break;}
                     case 3:  {price=((price>vbid)&&(price-vbid>=stop))? price:vbid+stop;break;}
                     case 4:  {price=((price>vask)&&(price-vask>=stop))? price:vask+stop;break;}
                     case 5:  {price=((price<vbid)&&(vbid-price>=stop))? price:vbid-stop;break;}
                     default: {Alert("00.BUY  01.SELL  02.BLIMIT  03.SLIMIT  04.BSTOP  05.SSTOP");break;}
                    }
                  }else {price=(z%2==0)?vask:vbid;}
               if(sl>0.0)//-- sl=sl if not violated, otherwise Sl=0.0
                 {
                  switch(z)//--sl
                    {
                     case 0: {sl=(vbid-sl>=stop)? sl:vbid-stop;break;}
                     case 1: {sl=(sl-vask>=stop)? sl:vask+stop;break;}
                     case 2: {sl=(price-sl>=stop)? sl:price-stop;break;}
                     case 3: {sl=(sl-price>=stop)? sl:price+stop;break;}
                     case 4: {sl=(price-sl>=stop)? sl:price-stop;break;}
                     case 5: {sl=(sl-price>=stop)? sl:price+stop;break;}
                     default: {Alert("00.BUY  01.SELL  02.BLIMIT  03.SLIMIT  04.BSTOP  05.SSTOP");break;}
                    }
                 }else sl=0.0;
               if(tp>0.0)//-- tp=tp if not violated, otherwise tp=0.0
                 {
                  switch(z)//--tp
                    {
                     case 0: {tp=(tp-vbid>=stop)? tp:vbid+stop;break;}
                     case 1: {tp=(vask-tp>=stop)? tp:vask-stop;break;}
                     case 2: {tp=(tp-price>=stop)? tp:price+stop;break;}
                     case 3: {tp=(price-tp>=stop)? tp:price-stop;break;}
                     case 4: {tp=(tp-price>=stop)? tp:price+stop;break;}
                     case 5: {tp=(price-tp>=stop)? tp:price-stop;break;}
                     default: {Alert("00.BUY  01.SELL  02.BLIMIT  03.SLIMIT  04.BSTOP  05.SSTOP");break;}
                    }
                 }else tp=0.0;               
               //----------------------------------------------------------------------------------------
               //OPEN -Place an order (BUY||SELL||PENDING)
               color colo;colo=(z%2==0)? clrNavy:clrMaroon;
               //---
               lp=10;while(lp>=0&&!IsStopped())
               {ResetLastError();
               o_send=OrderSend(Symbol(),z,Lot,price,ctr,sl,tp,EAName,EANumbers,TimeCurrent() + 60 * (60 * 4),colo);
               if(o_send<0){o_send=-1;lp--;Sleep(tsleep);continue;}//Sleep(tsleep);
               else
               if(o_send>=0) {rtn=true;break;}
               }
            break;//--break x=0
            }//case 0
  
      case 1:
            {

            switch(y)
                  {
                     case 1://CLOSE 
                     {
                        double pr=OrderClosePrice();
                        lp=10;while(lp>=0&&!IsStopped())
                        {ResetLastError();
                        if(OrderClose(o_send,o_lot,pr,ctr,clrGold))
                        {
                           rtn=ea_c=true;break;
                        }
                        else {lp--;Sleep(tsleep);continue;}}
                     break;//--break y=1
                     }//end of Close order
                     //+------------------------------------------------------------------+
                     case 2://DELETE
                     {
                        lp=10;while(lp>=0&&!IsStopped())
                        {ResetLastError();
                        if(OrderDelete(o_send,clrNONE))
                        {
                           rtn=true;break;
                        }
                        else {lp--;Sleep(tsleep);continue;}}
                     break;//--break y=2
                     }
                     //+------------------------------------------------------------------+
                     case 3://MODIFY pending-OPr+sl+tp  and instant-sl+tp
                     {
                        //---
                           if(price>0.0)//--ini untuk ubah open price pending order sahaja
                             {
                              switch(z)//--price
                                {
                                 //case 0:  {price=price;break;}
                                 //case 1:  {price=price;break;}
                                 case 2:  {price=(price<vask&&vask-price>freeze)? price:vask-freeze;break;}
                                 case 3:  {price=(price>vbid&&price-vbid>freeze)? price:vbid+freeze;break;}
                                 case 4:  {price=(price>vask&&price-vask>freeze)? price:vask+freeze;break;}
                                 case 5:  {price=(price<vbid&&vbid-price>freeze)? price:vbid-freeze;break;}
                                }
                             }else {price=price;}
                           
                           if(sl>0.0)//-- sl=sl if not violated, otherwise Sl=0.0
                             {
                              switch(z)//--sl
                                {
                                 case 0: {sl=(vbid-sl>freeze)? sl:vbid-freeze;break;}
                                 case 1: {sl=(sl-vask>freeze)? sl:vask+freeze;break;}
                                 case 2: {sl=(price-sl>=stop)? sl:price-stop;break;}
                                 case 3: {sl=(sl-price>=stop)? sl:price+stop;break;}
                                 case 4: {sl=(price-sl>=stop)? sl:price-stop;break;}
                                 case 5: {sl=(sl-price>=stop)? sl:price+stop;break;}
                                }
                             }else sl=0.0;

                           if(tp>0.0)//-- tp=tp if not violated, otherwise tp=0.0
                             {
                              switch(z)//--tp
                                {
                                 case 0: {tp=(tp-vbid>freeze)? tp:vbid+freeze;break;}
                                 case 1: {tp=(vask-tp>freeze)? tp:vask-freeze;break;}
                                 case 2: {tp=(tp-price>=stop)? tp:price+stop;break;}
                                 case 3: {tp=(price-tp>=stop)? tp:price-stop;break;}
                                 case 4: {tp=(tp-price>=stop)? tp:price+stop;break;}
                                 case 5: {tp=(price-tp>=stop)? tp:price-stop;break;}
                                }
                             }
                           else tp=0.0;
                        //---                        //---
                        color wrn;wrn=(z%2==0)? clrAqua:clrMagenta;
                        //static double s_price=0.0,s_st=0.0,s_tp=0.0;
                        //---
                        //---
                        if((s_price!=price)||(s_st!=sl || s_tp!=tp))
                        {
                        s_price=price;s_st=sl;s_tp=tp;
                        //---
                           //---
                           lp=10;while(lp>=0&&!IsStopped())
                           {ResetLastError();
                           if(OrderModify(o_send,s_price,s_st,s_tp,0,wrn)){rtn=true;break;}
                           else {Print("modify error!!");lp--;Sleep(tsleep);continue;}}
                        }   
                     break;//--break y=3
                     }//end of Modification if(code==3)//MODIFY
                  default :   {Alert("11x=CLOSE 12x=DELETE 13x=MODIFY");break;}
                  }//--switch y
         //---
         break;
         }//--end of case 0
     }//--End switch x
   }//--if(price==0.0)
   return rtn;  
  }  

//+------------------------------------------------------------------+
//|                         Money Management       Tn=a+(n-1)d       |
//+------------------------------------------------------------------+
double io::mmgm(int mtyp,int act=0)
{
   static double rtnlot=Lotstart;
   double 
   minlot=MarketInfo(Symbol(),MODE_MINLOT);if(Lotstart<minlot)Lotstart=minlot;
   if(mtyp%2==0)
   {
      if(act==0)rtnlot=Lotstart;
      else
      rtnlot=(rtnlot+lot_increment);
   }  
   if(mtyp%2==1)
   {
      if(act==0)rtnlot=Lotstart;
      else
      rtnlot=(rtnlot+lot_increment);
   }  
      if(AccountFreeMarginCheck(Symbol(),mtyp%2,rtnlot)<=0.0)return 0.0;
return(rtnlot);

}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
void data::calc()
{
   for(int i=sz-1; i>=0; i--)
   {
   will[i]=iWPR(_Symbol,TF[tf],14,i);
   rsi_14[i]=iRSI(_Symbol,TF[tf],14,PRICE_CLOSE,i);
   mom14[i]=iMomentum(_Symbol,TF[tf],14,PRICE_CLOSE,i);
   stc_fast[i]=iStochastic(_Symbol,TF[tf],5,3,3,MODE_SMA,0,MODE_MAIN,i);
   stc_slow[i]=iStochastic(_Symbol,TF[tf],5,3,3,MODE_SMA,0,MODE_SIGNAL,i);
   }
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int data::base(int p=0)
{
static int trig=0,tric=0,trik=0,trim;
   if(p==0)
   {
   osc(will[0],will[1],-80.0,-20.0,-50.0,-50.0,tric);
   osc(stc_fast[0],stc_slow[0],20.0,80.0,50.0,50.0,trik);
   osc(rsi_14[0],rsi_14[1],30.0,70.0,50.0,50.0,trig);
   osc(mom14[0],mom14[1],100.0,100.0,100.0,100.0,trim);
   //---
   if(tric== 1&&trik== 1&&(trig== 1 || trim== 1)){return  1;}
   else
   if(tric==-1&&trik==-1&&(trig==-1 || trim==-1)){return -1;}
   //---
   }
   else
   {
   //trig=0;
   
   }
return 0;
}
void osc(double pr0,double pr1, double valueB_mula,double valueS_mula,double valueB_akhir,double valueS_akhir, int &t)
{
   if(pr0<valueB_mula){t= 1;}
   else
   if(pr0>valueS_mula){t=-1;}
   //------------------------
   if(t== 1){if(pr0>valueB_akhir){t=0;}}
   else
   if(t==-1){if(pr0<valueS_akhir){t=0;}}
}